<script lang="ts">
    import Sidebar from './components/partials/Sidebar/Sidebar.vue'
    import Navbar from './components/partials/Navbar/Navbar.vue'
    import { useRoute } from 'vue-router';
    import { watch, getCurrentInstance, onMounted, computed,h,markRaw } from 'vue'
    import { FontAwesomeIcon } from '@fortawesome/vue-fontawesome'
 
    import type { AnyRecord } from 'dns';
    const faIcon = (props:any) => {
      return {
        element: markRaw({
          render: () => h('div', [
            h(FontAwesomeIcon, { size: 'lg', ...props })
          ])
        })
      }
    }

    export default {
    components : {
        Sidebar,
        Navbar        
    },
    data(){
        return {
            items: this.getMenu(),
            collapsed: true,
            themes: [
                {
                  name: 'Default theme',
                  input: ''
                },
                {
                  name: 'White theme',
                  input: 'white-theme'
                }
            ],
            selectedTheme: localStorage.selectedTheme,
            isOnMobile: true,
        }
    },
    setup () {
      const currentRoute = computed(() => {
        return useRoute().name || ' '
      })
      return { currentRoute }
    },

    mounted () {
      this.onResize()
      window.addEventListener('resize', this.onResize)
      if (localStorage.selectedTheme) {
        this.selectedTheme = localStorage.selectedTheme;
      }
      if (localStorage.collapsed) {
        const isTrueSet = (localStorage.collapsed === 'true');
        this.collapsed = isTrueSet;
      }
    },
    methods: {
      getDark(event:any){
        if(event)
        {
          this.selectedTheme=""
        }
        else{
          this.selectedTheme="white-theme"
        }
          localStorage.setItem('selectedTheme', this.selectedTheme)
      },
      onToggleCollapse (collapsed:any) {
        localStorage.setItem('collapsed', collapsed)
      },
      onItemClick (event:any, item:object) {
      },
      onResize () {
        if (window.innerWidth <= 767) {
          this.isOnMobile = true
          this.collapsed = true
        } else {
          this.isOnMobile = false
          this.collapsed = false
        }
      },
      getMenu(){
          const items= this.$router.options.routes;
          let menu = items.map(item => {
              delete item.component;
          let child:any = [];
          if( item.children !== undefined)
          {
            child = item.children.map(i => {
                  i.path = item.path +'/'+i.path
                  delete i.component;
                  i.nameIcon = i.icon
                  i.icon = faIcon({icon: i.icon})
                  return {...i}
              })
          }
            item.nameIcon = item.icon
            item.icon = faIcon({icon: item.icon })
            return { children: child, ...item,}
        })
        return menu;

      },
      getIcon(currentRoute:any){
        let found = this.items.find(element => element.name === currentRoute);
        let icon = found?.nameIcon || ''
        if(!found){
          found = this.items.find(element => element.children.find(el=> el.name === currentRoute));
          let foundChild = found?.children.find(el=> el.name === currentRoute)
          icon = foundChild?.nameIcon || 'fa-solid fa-bug'; 
        }
        //
        return icon
      }
    }
  }
</script>


<template>
  <Sidebar 
      :menu = "items"
      v-model:collapsed="collapsed"
      :theme="selectedTheme"
      :show-one-child="true"
      @update:collapsed="onToggleCollapse"
      @item-click="onItemClick" />
      <div
      v-if="isOnMobile && !collapsed"
      class="sidebar-overlay"
      @click="collapsed = true"
  />
    
  <div id="containerApp" :class="[{'collapsed' : collapsed}, {'onmobile' : false}]">
    <Navbar @get-dark="getDark($event)" :theme="selectedTheme" />
    <div v-if="currentRoute!='Welcome'">
      <header class="page-header page-header-dark pb-10" >
        <div class="container-xl px-4">
          <div class="page-header-content pt-4">
            <div class="row align-items-center justify-content-between">
                <div class="col-auto mt-4">
                    <h1 class="page-header-title">
                        <div class="page-header-icon">
                          <font-awesome-icon :icon="getIcon(currentRoute)" />
                        </div>
                        {{ currentRoute  }}
                    </h1>
                    <div class="page-header-subtitle">La DEP a été mis à jour le 06/12/2022 - 16:18:29</div>
                </div>

            </div>
          </div>
        </div>
      </header>

      <div class=" px-4 mt-n10">
            <router-view  />    
      </div>
    </div>
    <div v-else>
      <header class="page-header page-header-dark pb-10" >
        <div class="container-xl px-4">
          <div class="page-header-content pt-4">
            <div class="row align-items-center justify-content-between">
                <div class="col-auto mt-4">
                    <h1 class="page-header-title">
                        <div class="page-header-icon">
                          <font-awesome-icon icon="fa-solid fa-hands-clapping" />
                        </div>
                        Bonjour Baptiste
                    </h1>
                    <div class="page-header-subtitle">Tu peux retrouver l'actu de Willemse ci-dessous <font-awesome-icon icon="fa-solid fa-arrow-down" /></div>
                    <div class="page-header-subtitle">Si tu veux ajouter ou changer des informations du Dashboard, vous pouvez vous rapprochez de Batou</div>
                </div>

            </div>
          </div>
        </div>
      </header>

      <div class="container-fluid container-xl px-4 mt-n10">
            <router-view  />    
      </div>
    </div>
  </div>

</template>


<style lang="scss">
    :root {
        --primary: #4ade80;
        --primary-alt: #22c55e;
        --grey: #64748b;
        --dark: #1e293b;
        --dark-alt: #334155;
        --light: #f1f5f9;
        --sidebar-width: 300px;
    }
    * {
        margin: 0;
        padding: 0;
        box-sizing: border-box;
        font-family: 'Fira sans', sans-serif;
    }
    body,
html {
  margin: 0;
  padding: 0;
}
body {
  font-family: 'Source Sans Pro', sans-serif;
  font-size: 18px;
  background-color: #f2f4f7;
  color: #262626;
}
#containerApp {
  padding-left: 290px;
  transition: 0.3s ease;
}
#containerApp.collapsed {
  padding-left: 65px;
}
#containerApp.onmobile {
  padding-left: 65px;
}
.sidebar-overlay {
  position: fixed;
  width: 100%;
  height: 100%;
  top: 0;
  left: 0;
  background-color: #000;
  opacity: 0.5;
  z-index: 900;
}
.containerApp {
  padding: 30px;
}
.container {
  max-width: 900px;
}
</style>